(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Util

let parse_stmts filename =
	let ch = open_in filename in
try
	let blocks = Asmparser.blocks Asmlexer.token (Lexing.from_channel ch) in
	Convert_to_gas.convert Format.std_formatter blocks
with Parsing.Parse_error ->
	failwithf "Parse error at line %d\n" !Asmerror.line_number

let assemble filename =
	ignore (parse_stmts filename)

let specs = []

let main () =
try
	Arg.parse specs (fun filename -> assemble filename) "usage : assembler filename"
with Failure msg ->
	print_endline msg

let _ =
	let is_interactive = !Sys.interactive in
	if is_interactive then
		()
	else
		main ()
