(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

(* Machine-dependent (for IA32) *)

open Nativeint
open Machine

type elf32_addr		= nativeint
type elf32_half		= nativeint
type elf32_off		= nativeint
type elf32_sword	= nativeint
type elf32_word		= nativeint

let elf32_addr_size	= 4
let elf32_half_size	= 2
let elf32_off_size	= 4
let elf32_sword_size	= 4
let elf32_word_size	= 4

type field_info =
{
	fi_off	: int;
	fi_size	: int;
}

let next_off fi = fi.fi_off + fi.fi_size

let get_field seg fi =
	let { fi_size = sz; fi_off = off; } = fi in
	get_uint_of_size sz seg off

let rec get_headers_common seg off entsize num getter =
	if num = 0 then []
	else

	let seg' = get_subseg seg off entsize in
	let header = getter seg' in
	let headers = get_headers_common seg (off + entsize) entsize (num - 1) getter in

	header :: headers
