(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Instructions

open Format

let output_opsize ppf opsize =
	match opsize with
	| OpSize8 -> fprintf ppf "8"
	| OpSize16 -> fprintf ppf "16"
	| OpSize32 -> fprintf ppf "32"
	| OpSize48 -> fprintf ppf "48"
	| OpSize64 -> fprintf ppf "64"
	| OpSize128 -> fprintf ppf "128"

let output_optype ppf optype =
	match optype with
	| OT_w -> fprintf ppf "w"
	| OT_v -> fprintf ppf "v"
	| OT_s -> fprintf ppf "s"
	| OT_si -> fprintf ppf "si"
	| OT_ss -> fprintf ppf "ss"
	| OT_sd -> fprintf ppf "sd"
	| OT_p -> fprintf ppf "p"
	| OT_pi -> fprintf ppf "pi"
	| OT_ps -> fprintf ppf "ps"
	| OT_pd -> fprintf ppf "pd"
	| OT_q -> fprintf ppf "q"
	| OT_dq -> fprintf ppf "dq"
	| OT_d -> fprintf ppf "d"
	| OT_c -> fprintf ppf "c"
	| OT_b -> fprintf ppf "b"
	| OT_a -> fprintf ppf "a"

let output_admethod ppf adm =
	match adm with
	| AM_A -> fprintf ppf "A"
	| AM_C -> fprintf ppf "C"
	| AM_D -> fprintf ppf "D"
	| AM_E -> fprintf ppf "E"
	| AM_F -> fprintf ppf "F"
	| AM_G -> fprintf ppf "G"
	| AM_I -> fprintf ppf "I"
	| AM_J -> fprintf ppf "J"
	| AM_M -> fprintf ppf "M"
	| AM_O -> fprintf ppf "O"
	| AM_P -> fprintf ppf "P"
	| AM_Q -> fprintf ppf "Q"
	| AM_R -> fprintf ppf "R"
	| AM_S -> fprintf ppf "S"
	| AM_T -> fprintf ppf "T"
	| AM_V -> fprintf ppf "V"
	| AM_W -> fprintf ppf "W"
	| AM_X -> fprintf ppf "X"
	| AM_Y -> fprintf ppf "Y"
