(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Machine
open Read_elf_common
open Read_types_common

(* Machine-dependent (for IA32) *)

let name_of_section_for_named_types = ".namedtypes"

let rec read_named_type_definitions seg off =
	if off >= seg.seg_size then []
	else

	let off, name = read_string seg off in
	let off, ntd = read_named_type_definition seg off in

	let ntd = Convert_from_readable.convert_named_type_definition [] ntd in

	let rst = read_named_type_definitions seg off in

	(name, ntd) :: rst

let read_named_type_definition_wrap seg =
	read_named_type_definitions seg 0

let get_named_types ectx seg =
	get_sections_by_name
		name_of_section_for_named_types
		(Util.StringMap.empty : Types.named_type_definition Util.StringMap.t)
		read_named_type_definition_wrap
		Util.StringMap.add
		ectx
		seg
