(*
 * Copyright 2005 Toshiyuki Maeda
 *
 * This file is part of TALK.
 *
 * TALK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * TALK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *)

open Types
open Readable_annotations

open Util

type block =
{
	blk_segment     : Machine.segment;
	blk_heap_type   : Types.heap_type;
}

type code_block =
{
	cblk_segment	: Machine.segment;
	cblk_code_type	: Types.code_type;
}

type global_context =
{
	gctx_named_type_definitions : named_type_definition StringMap.t;

	gctx_code_store             : code_store;

	(* Annotations *)
	gctx_annots_map	           : all_annots NativeintMap.t;
}
